'  2008 Michele Leroux Bustamante. All rights reserved 
' Book: Learning WCF, O'Reilly
' Book Blog: www.thatindigogirl.com
' Michele's Blog: www.dasblonde.net
' IDesign: www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Navigation
Imports System.Windows.Shapes

Namespace Client
	''' <summary>
	''' Interaction logic for Window1.xaml
	''' </summary>
	Partial Public Class Window1
		Inherits Window
		Public Sub New()
			InitializeComponent()
		End Sub



		Private Sub button2_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			' proxy uses default windows credential unless provided
			Dim crudProxy As New Crud.CrudServiceClient("crudServiceWindows")
			If (Not String.IsNullOrEmpty(Me.txtUsername.Text)) AndAlso (Not String.IsNullOrEmpty(Me.txtPassword.Password)) Then
				crudProxy.ClientCredentials.Windows.ClientCredential = New System.Net.NetworkCredential(Me.txtUsername.Text, Me.txtPassword.Password)
			End If

			Try
				MessageBox.Show(crudProxy.CreateSomething())
				MessageBox.Show(crudProxy.ReadSomething())
				MessageBox.Show(crudProxy.UpdateSomething())
				MessageBox.Show(crudProxy.DeleteSomething())
			Catch ex As Exception
				MessageBox.Show(ex.Message)
			Finally
				If crudProxy.State = System.ServiceModel.CommunicationState.Faulted Then
					crudProxy.Abort()
				Else
					crudProxy.Close()
				End If
			End Try

		End Sub

		Private Sub button1_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			' provide proxy with username/password
			Dim crudProxy As New Crud.CrudServiceClient("crudServiceUserName")
			If String.IsNullOrEmpty(Me.txtUsername.Text) OrElse String.IsNullOrEmpty(Me.txtPassword.Password) Then
				Throw New InvalidOperationException("You must supply a username and password.")
			End If
			crudProxy.ClientCredentials.UserName.UserName = Me.txtUsername.Text
			crudProxy.ClientCredentials.UserName.Password = Me.txtPassword.Password

			Try
				MessageBox.Show(crudProxy.CreateSomething())
				MessageBox.Show(crudProxy.ReadSomething())
				MessageBox.Show(crudProxy.UpdateSomething())
				MessageBox.Show(crudProxy.DeleteSomething())
			Catch ex As Exception
				MessageBox.Show(ex.Message)
			Finally
				If crudProxy.State = System.ServiceModel.CommunicationState.Faulted Then
					crudProxy.Abort()
				Else
					crudProxy.Close()
				End If
			End Try

		End Sub
	End Class
End Namespace
