'  2008 Michele Leroux Bustamante. All rights reserved 
' Book: Learning WCF, O'Reilly
' Book Blog: www.thatindigogirl.com
' Michele's Blog: www.dasblonde.net
' IDesign: www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Runtime.Serialization
Imports System.ServiceModel
Imports System.Text
Imports Microsoft.IdentityModel.Configuration
Imports Microsoft.IdentityModel.Claims
Imports System.Security.Cryptography.X509Certificates
Imports WCFClaims = System.IdentityModel.Claims
Imports Microsoft.IdentityModel.SecurityTokenService
Imports System.IdentityModel.Tokens


Namespace STS
	Public Class IdentitySTS
		Inherits SecurityTokenService
		Public Sub New(ByVal config As SecurityTokenServiceConfiguration)
			MyBase.New(config)
		End Sub

		Protected Overrides Function GetOutputClaimsIdentity(ByVal principal As IClaimsPrincipal, ByVal request As RequestSecurityToken, ByVal scope As Scope) As IClaimsIdentity
			Dim claimsIdentity As IClaimsIdentity = New ClaimsIdentity()

			' TODO: look up Windows account and map to claims
			' this example hard codes a specific list of claims for any user identity
			claimsIdentity.Claims.Add(New Claim(WCFClaims.ClaimTypes.Name, principal.Identity.Name))
			claimsIdentity.Claims.Add(New Claim(Constants.ClaimTypes.Permission, Constants.Permissions.Create))
			claimsIdentity.Claims.Add(New Claim(Constants.ClaimTypes.Permission, Constants.Permissions.Read))
			claimsIdentity.Claims.Add(New Claim(Constants.ClaimTypes.Permission, Constants.Permissions.Update))

			Return claimsIdentity
		End Function

		Protected Overrides Function GetScope(ByVal principal As Microsoft.IdentityModel.Claims.IClaimsPrincipal, ByVal request As RequestSecurityToken) As Scope

			Dim scope As New Scope(request)
			scope.EncryptingCredentials = Me.GetCredentialsForAppliesTo(request.AppliesTo)
			scope.SigningCredentials = New X509SigningCredentials(CertificateUtil.GetCertificate(StoreName.My, StoreLocation.LocalMachine, "CN=IPKey"))

			Return scope
		End Function

		Private Function GetCredentialsForAppliesTo(ByVal appliesTo As EndpointAddress) As X509EncryptingCredentials
			If appliesTo Is Nothing OrElse appliesTo.Uri Is Nothing OrElse String.IsNullOrEmpty(appliesTo.Uri.AbsolutePath) Then
				Throw New InvalidRequestException("AppliesTo must be supplied in the RST.")
			End If

			Dim creds As X509EncryptingCredentials = Nothing
			If appliesTo.Uri.AbsoluteUri.StartsWith("http://localhost:49546/RPHostWeb/CrudService.svc") Then
				creds = New X509EncryptingCredentials(CertificateUtil.GetCertificate(StoreName.TrustedPeople, StoreLocation.LocalMachine, "CN=RPKey"))
			Else
				Throw New InvalidRequestException(String.Format("Invalid relying party address: {0}", appliesTo.Uri.AbsoluteUri))
			End If

			Return creds
		End Function
	End Class
End Namespace
